--------------------- Resolving endianness resolving routines ----------------

Provide(endian)

define({__LITTLE_ENDIAN__},{1234})
define({__BIG_ENDIAN__},{4321})


define({endian_reorder_4_bytes_from_1234_to_4321},{swap_4_bytes})
define({endian_reorder_4_bytes_from_4321_to_1234},{swap_4_bytes})
define({endian_reorder_4_bytes_from_1234_to_1234})
define({endian_reorder_4_bytes_from_4321_to_4321})
define({endian_reorder_2_bytes_from_1234_to_4321},{swap_2_bytes})
define({endian_reorder_2_bytes_from_4321_to_1234},{swap_2_bytes})
define({endian_reorder_2_bytes_from_1234_to_1234})
define({endian_reorder_2_bytes_from_4321_to_4321})


defdef({__C_DEFINE_BYTESWAP__},{

static __inline__ uint32 swap_4_bytes(uint32 x)
BEGIN
	union BEGIN uint32 u32; uint8 u8[4]; END X,Y ;
	X.u32 = x ;
	Y.u8[0] = X.u8[3] ;
	Y.u8[1] = X.u8[2] ;
	Y.u8[2] = X.u8[1] ;
	Y.u8[3] = X.u8[0] ;
	return Y.u32 ;
END
static __inline__ uint16 swap_2_bytes(uint16 x)
BEGIN
	union BEGIN uint16 u16; uint8 u8[4]; END X,Y ;
	X.u16 = x ;
	Y.u8[0] = X.u8[1] ;
	Y.u8[1] = X.u8[0] ;
	return Y.u16 ;
END
})

__C_CODE__({
__C_DEFINE_BYTESWAP__
})
