------------- Linux specific definitions for the OTOP subproject -------------

Provide({linux})

------ System "C" header files. ------

--- Standard C Headers:
define({__C_STD_INCLUDES__},{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
})

--- OS-specific I/O
define({__LLL_OS__},{C_unix})
define({__C_OS_INCLUDES__},{
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
})

--- Low-level TTY I/O
define({__LLL_TTYIO__},{C_termios})
define({__C_TTY_INCLUDES__},{
#include <termios.h>
})

--- Network subsystem
define({__C_NET_INCLUDES__},{
})




Text/Graphical User interface stuff below should really belong to
other configuration files, eg. svgalib.m4, x11.m4, etc, that autoconf
should define.

--- video text array
define({__LLL_VIDEOTEXT__},{C_ncurses})
define({__C_VIDEOTEXT_INCLUDES__},{
#include <ncurses/ncurses.h>
})

--- Hi-Res Video
We should let the user choose between NCURSES, SVGALIB and/or X11 at
compile-time or better, runtime.

define({__C_VIDEO_INCLUDES},{
ifdef({USES_SVGALIB},{
#include <vga.h>
})
ifdef({USES_X11},{
#include <X11/Xlib.h>
})
})
